#include		<windows.h>

#include		<conio.h>
#include		<stdio.h>

#include		"String.h"

HANDLE		handleConsole;
char		chKey;
char		chName[] = " ";

#define			FOREGROUND_WHITE FOREGROUND_RED | FOREGROUND_GREEN | FOREGROUND_BLUE

#define			GAME_EXIT		0x0156
#define			GAME_TOTALQUIT	0x1234
#define			GAME_NOWHERE	0x0001
#define			GAME_TRADER		0x0002
#define			GAME_ONPLACE	0x0003
#define			GAME_BATTLE		0x0004
#define			GAME_MAN		0x0005
#define			GAME_GOD		0x0006
#define			GAME_WOMAN		0x0007
#define			GAME_TAKOYYA	0x0008

void	Printf			( int x, int y, clString str );
void	SetColor		( int var );
void	FrameDraw		( int x0, int y0, int x1, int y1 );
void	BigFrameDraw	( void );

class		clManagerSprite;
class		clManagerWeapon;
class		clManagerMonster;
class		clPlayer;
class		clFight;
class		clGod;

namespace		Core
{

	clManagerSprite		* manspr_npc;
	clManagerSprite		* manspr_stf;
	clManagerWeapon		* manwpn;
	clManagerMonster	* manmon;
	clPlayer			* plr;
	clFight				* fht;
	clGod				* god;

	int			intGameState;
	int			intLevel;
	bool		boolPause;

};

typedef struct	_sLine
{
	char		chData[ 21 ];
}				sLine;

// PURE MANAGER

template		< typename T >
class			clManager
{

public:

	T			* data;
	int			intCount;

	virtual		void	Draw	( int num, int x, int y ) = 0;

private:

};

// Sprite

class			clSprite
{

public:

	sLine		lines[ 10 ];
	clString	strName;

	void		Draw		( int x, int y );

private:

};

void clSprite::Draw( int x, int y )
{
	COORD		mpos;
	
	mpos.X = x;
	mpos.Y = y;

	for( int i = 0; i < 10; i ++ )
	{
		mpos.X = x;
		mpos.Y ++;
	//	SetConsoleCursorPosition( handleConsole, mpos );
	//	printf( &this->lines[ i ].chData[ 0 ] );
		Printf( mpos.X, mpos.Y, &this->lines[ i ].chData[ 0 ] );
	}
}

class			clManagerSprite : public clManager< clSprite >
{

public:

	void		Draw	( int num, int x, int y );

				clManagerSprite	( char * ch );
	~			clManagerSprite	( void );

private:

};

void clManagerSprite::Draw( int num, int x, int y )
{
	this->data[ num ].Draw( x, y );
}

clManagerSprite::clManagerSprite( char * ch )
{
	FILE		* f;

	f = fopen( ch, "r" );
	this->intCount = 0;

	if( f )
	{
		fscanf( f, "%i", &this->intCount );
		fgetc( f );

		this->data = new clSprite[ this->intCount ];

		for( int i = 0; i < this->intCount; i ++ )
		{
			for( int j = 0; j < 10; j ++ )
			{
				memset( &this->data[ i ].lines[ j ].chData[ 0 ], 0, 21 );
				fgets( &this->data[ i ].lines[ j ].chData[ 0 ], 20, f );
				fgetc( f ); fgetc( f ); // OD OA
			}
			char	chName[ 256 ] = { 0 };
			fgets( chName, 256, f );
			chName[ strlen( chName ) - 1 ] = 0x00;	//    
			this->data[ i ].strName = chName;
		}

		fclose( f );
	}
	else
	{
		printf( "File %s not found", ch );
	}
}

clManagerSprite::~clManagerSprite( void )
{
	if( this->intCount )
	{
		delete [] this->data;
	}
}

// Weapon

class				clWeapon
{

public:

	int		intMinDmg, intMaxDmg;
	int		intCost;

private:

};

class			clManagerWeapon : public clManager< clWeapon >
{

public:

	clManagerSprite		mngSprite;

	void		Draw	( int num, int x, int y );

				clManagerWeapon		( clString strSprites, clString strFile );
	~			clManagerWeapon		( void );

private:

};

void clManagerWeapon::Draw( int num, int x, int y )
{
	mngSprite.Draw( num, x, y );
	Printf( x, y + 2, mngSprite.data[ num ].strName );
	Printf( x, y + 9, "    ATK : " );
	printf( "%i - %i", this->data[ num ].intMinDmg, this->data[ num ].intMaxDmg );
}

clManagerWeapon::clManagerWeapon( clString strSprites, clString strFile ) : mngSprite( strSprites )
{
	this->intCount = 0;
	FILE		* f;

	f = fopen( strFile, "r" );
	if( f )
	{
		fscanf( f, "%i", &this->intCount );
		this->data = new clWeapon[ this->intCount ];

		for( int i = 0; i < this->intCount; i ++ )
		{
			fscanf( f, "%i %i %i", 
				&this->data[ i ].intMinDmg, 
				&this->data[ i ].intMaxDmg, 
				&this->data[ i ].intCost );
		}

		fclose( f );
	}
	else
	{
		printf( "File %s not found", strFile() );
	}
}

clManagerWeapon::~clManagerWeapon( void )
{
	if( this->intCount )
	{
		delete [] this->data;
	}
}

class			clMonster
{

public:

	int			intHP;
	int			intHPmax;
	int			intMoneyMin;
	int			intMoneyMax;
	int			intDmgMin;
	int			intDmgMax;

private:

};

class			clManagerMonster : public clManager< clMonster >
{

public:

	clManagerSprite		mngSprite;

				clManagerMonster	( clString strSprites, clString strFile );
	~			clManagerMonster	( void );

	void		Draw	( int num, int x, int y );

private:

};

clManagerMonster::clManagerMonster( clString strSprites, clString strFile ) : mngSprite( strSprites )
{
	this->intCount = 0;
	FILE		* f;

	f = fopen( strFile, "r" );
	if( f )
	{
		fscanf( f, "%i", &this->intCount );
		this->data = new clMonster[ this->intCount ];

		for( int i = 0; i < this->intCount; i ++ )
		{
			fscanf( f, "%i %i %i %i %i", 
				&this->data[ i ].intHP, 
				&this->data[ i ].intDmgMin, 
				&this->data[ i ].intDmgMax,
				&this->data[ i ].intMoneyMin,
				&this->data[ i ].intMoneyMax );

			this->data[ i ].intHPmax = this->data[ i ].intHP;
		}

		fclose( f );
	}
	else
	{
		printf( "File %s not found", strFile() );
	}
}

clManagerMonster::~clManagerMonster( void )
{
	if( this->intCount )
	{
		delete [] this->data;
	}
}

void clManagerMonster::Draw( int num, int x, int y )
{
	mngSprite.Draw( num, x, y );
}

class			clMenuItem
{

public:

	clString	strName;
	bool		boolActive;
	
				clMenuItem	( void ) {};
	~			clMenuItem	( void ) {};

				clMenuItem	( clString name, bool active ) : strName( name ), boolActive( active ) {};

private:

};

class			clMenu
{

public:

	clMenuItem		data[ 5 ];
	int				intActive;
	int				intCount;

					clMenu	( void ) { this->intActive = 0; };
	~				clMenu	( void ) {};

	void			Free		( void );
	void			AddItem		( clMenuItem item );
	void			ChangeItem	( int num, clMenuItem item );
	void			Draw		( int x, int y );
	void			Update		( void );

private:

};

void clMenu::Free( void )
{
	this->intCount = 0;
}

void clMenu::AddItem( clMenuItem item )
{
	if( this->intCount + 1 <= 5 )
	{
		this->data[ this->intCount ] = item;
		this->intCount ++;
	}
	else
	{
		printf( "Too many menu items" );
	}
}

void clMenu::ChangeItem	( int num, clMenuItem item )
{
	this->data[ num ] = item;
}

void clMenu::Draw( int x, int y )
{
	for( int i = 0; i < this->intCount; i ++ )
	{
		if( this->data[ i ].boolActive )
		{
			SetColor( FOREGROUND_GREEN );
		}
		else
		{
			SetColor( FOREGROUND_WHITE );
		}

		char	ch[ 2 ];
		
		sprintf( ch, "%i", i + 1 );
		clString		strmess = ch;
		strmess += " - ";
		strmess += this->data[ i ].strName;

		Printf( x, y + i * 2, strmess );
	}
}

void clMenu::Update( void )
{
	this->intActive = 0;

	for( int i = 0; i < 5; i ++ )
	{
		if( this->data[ i ].boolActive )
		{
			this->intActive = i;
			break;
		}
	}

	if( chKey == 80 )
	{
		this->data[ this->intActive ].boolActive = false;
		this->intActive ++;
		if( this->intActive > this->intCount - 1 )
		{
			this->intActive = 0;
		}
		this->data[ this->intActive ].boolActive = true;
	}

	if( chKey == 72 )
	{
		this->data[ this->intActive ].boolActive = false;
		this->intActive --;
		if( this->intActive < 0 )
		{
			this->intActive = this->intCount - 1;
		}
		this->data[ this->intActive ].boolActive = true;
	}
}

class			clNPC
{

public:

	clMenu		menu;
	clString	text[ 3 ];

	int			intText;

private:

};

class			clPlayer
{

public:

	int			intMoney;
	int			HP, HPmax;
	int			intWeapon;
	int			intPotion;
	int			intQuest;
	int			intQuestActive;

				clPlayer	( void ) : intMoney( 0 ), HP( 50 ), HPmax( 50 ), intWeapon( 0 ), intPotion( 0 ), intQuestActive( 0 ) {};
				clPlayer	( int money, int hp, int hpmax, int weapon, int potion ) :
							intMoney( money ), HP( hp ), HPmax( hpmax ), intWeapon( weapon ), intPotion( potion ), intQuest( 0 ), intQuestActive( 0 ) {};
	~			clPlayer	( void ) {};

	void		Process		( void );

private:

};

void clPlayer::Process( void )
{
	char		ch[ 256 ] = { 0 };

	// Info ( HP, Money, Name );
	SetColor( FOREGROUND_WHITE );
	Printf( 6, 17, chName );
	if( ( this->HP < this->HPmax / 3 ) )
	{
		SetColor( FOREGROUND_RED );
	}
	else if( ( this->HP < this->HPmax / 1.5 ) )
	{
		SetColor( FOREGROUND_RED | FOREGROUND_GREEN );
	}
	else
	{
		SetColor( FOREGROUND_GREEN );
	}
	sprintf( ch, "%i / %i HP", this->HP, this->HPmax );
	Printf( 8, 18, ch );
	SetColor( FOREGROUND_RED | FOREGROUND_GREEN );
	sprintf( ch, "%i ", this->intMoney );
	Printf( 8, 19, ch );
	SetColor( FOREGROUND_WHITE );
	// Face
	Core::manspr_npc->Draw( 0, 3, 2 );
	// Weapon
	Core::manwpn->Draw( this->intWeapon, 4, 22 );
	// Items
	SetColor( FOREGROUND_WHITE );
	Core::manspr_stf->Draw( 0, 0, 35 );
	Printf( 9, 44, "x" );
	SetColor( FOREGROUND_WHITE | FOREGROUND_INTENSITY );
	sprintf( ch, "%i", this->intPotion );
	Printf( 9, 45, ch );
	// Quest items
	SetColor( FOREGROUND_WHITE );
	if( this->intQuest )
	{
		Core::manspr_stf->Draw( this->intQuest, 13, 35 );
	}
	// Interface
	SetColor( FOREGROUND_WHITE );
	FrameDraw( 2, 2, 25, 10 );
	FrameDraw( 2, 15, 25, 17 );
	FrameDraw( 2, 22, 25, 30 );
	FrameDraw( 2, 35, 12, 43 );
	FrameDraw( 15, 35, 25, 43 );
	FrameDraw( 28, 30, 76, 43 );
}

class			clMan : public clNPC
{

public:

				clMan	( void );
	~			clMan	( void );

	void		Process	( void );

private:

};

clMan::clMan( void )
{
	this->menu.Free();
	this->menu.AddItem( clMenuItem( "!?  ?   ?", true ) );
	this->menu.AddItem( clMenuItem( ",     !", false ) );
	this->menu.AddItem( clMenuItem( "...     ?!", false ) );
}

clMan::~clMan( void )
{
}

void clMan::Process( void )
{
	this->text[ 0 ] = "  ...[]    ";
	this->text[ 1 ] = "...  ...[]";

	Printf( 31, 32, this->text[ 0 ] );
	Printf( 31, 33, this->text[ 1 ] );
	Printf( 31, 34, this->text[ 2 ] );
	this->menu.Update();
	this->menu.Draw( 32, 36 );
	SetColor( FOREGROUND_WHITE );
	Core::manspr_npc->Draw( 4, 56, 2 );
	FrameDraw( 55, 2, 76, 10 );

	if( chKey == 13 )
	{
		Core::intGameState = GAME_NOWHERE;
	}
}

class			clGod : public clNPC
{

public:

				clGod		( void );
	~			clGod		( void );

	void		Process		( void );

private:

};

clGod::clGod( void )
{
	this->menu.Free();
	this->menu.AddItem( clMenuItem( "", true ) );
	this->intText = 0x00;
}

clGod::~clGod( void )
{
}

void clGod::Process( void )
{
	if( ( chKey == 13 ) && ( this->menu.intActive == 0 ) )
	{
		this->intText ++;
	}

	switch( this->intText )
	{
	case 0 :
		this->text[ 0 ] = "       ,";
		this->text[ 1 ] = "       .";
		this->text[ 2 ] = "  - ...";

		break;

	case 1 : 
		this->text[ 0 ] = " ,   ...";
		this->text[ 1 ] = "";
		this->text[ 2 ] = "";

		break;

	case 2 : 
		this->text[ 0 ] = "     ,  ";
		this->text[ 1 ] = "  , ";
		this->text[ 2 ] = "   ...";

		break;

	case 3 : 
		this->text[ 0 ] = "       ";
		this->text[ 1 ] = "    ...";
		this->text[ 2 ] = "";

		break;
	case 4 : 
		Core::intGameState = GAME_MAN;
		this->intText ++;

		break;
	case 5 :
		this->text[ 0 ] = "    ,  ";
		this->text[ 1 ] = "   .";
		this->text[ 2 ] = "";

		break;
	case 6 : 
		this->text[ 0 ] = "     , ";
		this->text[ 1 ] = "  ...";
		this->text[ 2 ] = "";

		break;
	case 7 : 
		this->text[ 0 ] = "      ";
		this->text[ 1 ] = "     ,  ";
		this->text[ 2 ] = " .";

		break;
	case 8 : 
		this->text[ 0 ] = "       ...";
		this->text[ 1 ] = "   - THE END -";
		this->text[ 2 ] = "   ...";

		break;
	case 9 : 
		this->text[ 0 ] = "   : faceH0r";
		this->text[ 1 ] = "   : jnz(  ),";
		this->text[ 2 ] = "Tiandong, NE_Mashinist(  forever )";

		break;
	case 10 : 
		this->text[ 0 ] = " (C) 22  2007 ";
		this->text[ 1 ] = "";
		this->text[ 2 ] = "";

		break;
	case 11 : 
		this->text[ 0 ] = " ";
		this->text[ 1 ] = "";
		this->text[ 2 ] = "";

		Core::intGameState = GAME_TOTALQUIT;

		break;
	case 12 : 
		this->text[ 0 ] = "   ,  ...";
		this->text[ 1 ] = "  ...  ...";
		this->text[ 2 ] = "  ... THE END";

		break;
	case 13 : 
		Core::intGameState = GAME_TOTALQUIT;

		break;
	}

	Printf( 31, 32, this->text[ 0 ] );
	Printf( 31, 33, this->text[ 1 ] );
	Printf( 31, 34, this->text[ 2 ] );
	this->menu.Update();
	this->menu.Draw( 32, 36 );
}

class			clFight : public clNPC
{

public:

	int			intMonster;

				clFight		( void );
	~			clFight		( void );

	void		CheckDead	( void );

	void		Process		( void );

private:

};

clFight::clFight( void )
{
	this->menu.Free();
	this->menu.AddItem( clMenuItem( " ", true ) );
	this->menu.AddItem( clMenuItem( "  ", false ) );
	this->menu.AddItem( clMenuItem( "", false ) );
	this->intMonster = 0x00;
}

clFight::~clFight( void )
{
}

void clFight::Process( void )
{
	this->text[ 0 ] = "   ";
	this->text[ 0 ] += Core::manmon->mngSprite.data[ this->intMonster ].strName();

	SetColor( FOREGROUND_WHITE );
	Core::manmon->mngSprite.Draw( this->intMonster, 43, 11 );

	if( ( chKey == 13 ) && ( this->menu.intActive == 0 ) )
	{
		int		del_dmg = Core::manmon->data[ this->intMonster ].intDmgMax - Core::manmon->data[ this->intMonster ].intDmgMin + 1;
		int		dmg = Core::manmon->data[ this->intMonster ].intDmgMin + rand() % del_dmg;
		Core::plr->HP -= dmg;
		char		ch[ 256 ];
		memset( ch, 0, 256 );
		sprintf( ch, "%s    %i HP", Core::manmon->mngSprite.data[ this->intMonster ].strName(), dmg ); 
		SetColor( FOREGROUND_WHITE | FOREGROUND_INTENSITY );
		Printf( 31, 28, ch );
		SetColor( FOREGROUND_RED );
		Printf( 52, 15, ".*/" );
		Printf( 51, 16, "<-&->" );
		Printf( 52, 17, "'|'" );
		memset( ch, 0, 256 );
		del_dmg = Core::manwpn->data[ Core::plr->intWeapon ].intMaxDmg - Core::manwpn->data[ Core::plr->intWeapon ].intMinDmg + 1;
		dmg = Core::manwpn->data[ Core::plr->intWeapon ].intMinDmg + rand() % del_dmg;
		Core::manmon->data[ this->intMonster ].intHP -= dmg;
		sprintf( ch, "  %s  %i HP", Core::manmon->mngSprite.data[ this->intMonster ].strName(), dmg ); 
		if( dmg == Core::manwpn->data[ Core::plr->intWeapon ].intMaxDmg )
		{
			strcat( ch, " !CRIT!" );
		}
		SetColor( FOREGROUND_WHITE | FOREGROUND_INTENSITY );
		Printf( 31, 27, ch );
		SetColor( FOREGROUND_WHITE );

		this->CheckDead();
	}
	if( ( chKey == 13 ) && ( this->menu.intActive == 1 ) )
	{
		if( Core::plr->intPotion > 0 )
		{
			int		hlt = 15 + ( rand() % 25 );
			Core::plr->HP += hlt;
			if( Core::plr->HP > Core::plr->HPmax )
			{
				Core::plr->HP = Core::plr->HPmax;
			}
			Core::plr->intPotion --;

			char		ch[ 256 ];
			memset( ch, 0, 256 );
			sprintf( ch, "  %i HP", hlt ); 
			SetColor( FOREGROUND_WHITE | FOREGROUND_INTENSITY );
			Printf( 31, 28, ch );
		}
		else
		{
			this->text[ 0 ] = " ";
		}
	}
	if( ( chKey == 13 ) && ( this->menu.intActive == 2 ) )
	{
		Core::intGameState = GAME_ONPLACE;
	}

	char		ch[ 256 ];
	memset( ch, 0, 256 );
	sprintf( ch, "%i HP", Core::manmon->data[ this->intMonster ].intHP );
	Printf( 43, 9, ch );
	Printf( 31, 32, this->text[ 0 ] );
	Printf( 31, 33, this->text[ 1 ] );
	Printf( 31, 34, this->text[ 2 ] );
	this->menu.Update();
	this->menu.Draw( 32, 36 );
}

void clFight::CheckDead( void )
{
	if( Core::manmon->data[ this->intMonster ].intHP <= 0 )
	{
		int		del_mny = Core::manmon->data[ this->intMonster ].intMoneyMax - Core::manmon->data[ this->intMonster ].intMoneyMin + 1;
		int		mny = Core::manmon->data[ this->intMonster ].intMoneyMin + rand() % del_mny;

		char		ch[ 256 ];
		memset( ch, 0, 256 );
		sprintf( ch, "  %s  %i ", Core::manmon->mngSprite.data[ this->intMonster ].strName(), mny );
		Printf( 31, 28, ch );
		Core::plr->intMoney += mny;

		Core::intGameState = GAME_ONPLACE;
		Core::boolPause = true;

		if( this->intMonster == 2 )
		{
			this->text[ 0 ] = "   ";
			Core::plr->intQuest = 1;
		}

		if( this->intMonster == 5 )
		{
			this->text[ 0 ] = "    ";
			Core::plr->intQuest = 2;
		}

		if( this->intMonster == 8 )
		{
			this->text[ 0 ] = ", !!!";
			Core::boolPause = true;
			Core::god->intText = 5;
			Core::intGameState = GAME_GOD;
		}
	}
	if( Core::plr->HP <= 0 )
	{
		Core::intGameState = GAME_GOD;
		Core::god->intText = 12;
	}
}

class			clNowhere : public clNPC
{

public:

				clNowhere	( void );
	~			clNowhere	( void );

	void		Process		( void );

private:

};

clNowhere::clNowhere( void )
{
	this->menu.Free();
	this->menu.AddItem( clMenuItem( ",      ?", true ) );
	this->menu.AddItem( clMenuItem( "  ", false ) );
	this->menu.AddItem( clMenuItem( "  ", false ) );
	this->menu.AddItem( clMenuItem( "", false ) );
	this->menu.AddItem( clMenuItem( "    ", false ) );
}

clNowhere::~clNowhere( void )
{
}

void clNowhere::Process( void )
{
	if( Core::intLevel != 2 )
	{
		this->text[ 0 ] = "  ?";
		this->text[ 1 ] = "";
		this->text[ 2 ] = "";
	}
	else
	{
		this->text[ 0 ] = "      .  ";
		this->text[ 1 ] = ".";
		this->text[ 2 ] = "";
	}
	switch( Core::intLevel )
	{
	case 0 :
		this->menu.data[ 3 ].strName = "  ";
		break;
	case 1 :
		this->menu.data[ 3 ].strName = "  ";
		break;
	case 2 :
		this->menu.data[ 3 ].strName = "   ";
	}
	if( ( chKey == 13 ) && ( this->menu.intActive == 0 ) )
	{
		switch( Core::intLevel )
		{
		case 0 :
			this->text[ 0 ] = "  ,    .";
			this->text[ 1 ] = "  .";
			this->text[ 2 ] = "";
			
			break;
		case 1:
			this->text[ 0 ] = "      ,";
			this->text[ 1 ] = "    .";
			this->text[ 2 ] = "";

			break;
		case 2:
			this->text[ 0 ] = "     !!! !";
			this->text[ 1 ] = "";
			this->text[ 2 ] = "";

			break;
		}
	}
	if( ( chKey == 13 ) && ( this->menu.intActive == 1 ) )
	{
		Core::intGameState = GAME_TRADER;
	}
	if( ( chKey == 13 ) && ( this->menu.intActive == 2 ) )
	{
		if( Core::plr->intQuestActive )
		{
			Core::intGameState = GAME_ONPLACE;
		}
		else if( Core::intLevel == 2 )
		{
			Core::intGameState = GAME_ONPLACE;
		}
		else
		{
			this->text[ 0 ] = "    .";
			this->text[ 1 ] = "";
			this->text[ 2 ] = "";
		}
	}
	if( ( chKey == 13 ) && ( this->menu.intActive == 3 ) )
	{
		switch( Core::intLevel )
		{
		case 0 :
			Core::intGameState = GAME_WOMAN;

			break;
		case 1:
			Core::intGameState = GAME_TAKOYYA;

			break;
		}
	}
	if( ( chKey == 13 ) && ( this->menu.intActive == 4 ) )
	{
		Core::intGameState = GAME_EXIT;
	}
	Printf( 31, 32, this->text[ 0 ] );
	Printf( 31, 33, this->text[ 1 ] );
	Printf( 31, 34, this->text[ 2 ] );
	this->menu.Update();
	this->menu.Draw( 32, 36 );
}

class			clTrader : public clNPC
{

public:

				clTrader	( void );
	~			clTrader	( void );

	void		Process		( void );

private:

};

clTrader::clTrader	( void )
{
	this->menu.Free();
	this->menu.AddItem( clMenuItem( "   ?", true ) );
	this->menu.AddItem( clMenuItem( "   ( 250  )", false ) );
	this->menu.AddItem( clMenuItem( "", false ) );
	this->menu.AddItem( clMenuItem( "  ", false ) );
	this->text[ 0 ] = ", .     ?";
}

clTrader::~clTrader	( void )
{

}

void clTrader::Process	( void )
{
	if( ( chKey == 13 ) && ( this->menu.intActive == 0 ) )
	{
		this->text[ 0 ] = "  , .";
	}

	if( ( chKey == 13 ) && ( this->menu.intActive == 1 ) )
	{
		if( Core::plr->intMoney >= 250 )
		{
			this->text[ 0 ] = "  \" \".";
			Core::plr->intMoney -= 250;
			Core::plr->intPotion ++;
		}
		else
		{
			this->text[ 0 ] = "   .";
		}
	}

	if( ( chKey == 13 ) && ( this->menu.intActive == 2 ) )
	{
		if( Core::plr->intWeapon >= 4 )
		{
			this->text[ 0 ] = "    ";
		}
		else
		{
			if( Core::plr->intMoney >= Core::manwpn->data[ Core::plr->intWeapon + 1 ].intCost )
			{
				Core::plr->intWeapon ++;
				if( Core::plr->intWeapon >= 4 )
				{
					Core::plr->intWeapon = 4;
				}
				this->text[ 0 ] = "  \"";
				this->text[ 0 ] += Core::manwpn->mngSprite.data[ Core::plr->intWeapon ].strName();
				this->text[ 0 ] += "\"";
				Core::plr->intMoney -= Core::manwpn->data[ Core::plr->intWeapon ].intCost;
				
			}
			else
			{
				this->text[ 0 ] = "      ";
			}
		}
	}

	if( ( chKey == 13 ) && ( this->menu.intActive == 3 ) )
	{
		Core::intGameState = GAME_NOWHERE;
	}

	Printf( 31, 32, this->text[ 0 ] );
	Printf( 31, 33, this->text[ 1 ] );
	Printf( 31, 34, this->text[ 2 ] );
	clMenuItem		tmp = this->menu.data[ 2 ];
	char			chMsg[ 256 ];
	memset( chMsg, 0, 256 );
	//  ,  
	if( Core::plr->intWeapon < 4 )
	{
		sprintf( chMsg, " \"%s\"  %i .", Core::manwpn->mngSprite.data[ Core::plr->intWeapon + 1 ].strName(), Core::manwpn->data[ Core::plr->intWeapon + 1 ].intCost );
	}
	else
	{
		sprintf( chMsg, " \"%s\"  %i .", Core::manwpn->mngSprite.data[ Core::plr->intWeapon ].strName(), Core::manwpn->data[ Core::plr->intWeapon ].intCost );
	}
	tmp.strName = chMsg;
	this->menu.ChangeItem( 2, tmp );
	this->menu.Update();
	this->menu.Draw( 32, 36 );
	SetColor( FOREGROUND_WHITE );
	Core::manspr_npc->Draw( 3, 56, 2 );
	FrameDraw( 55, 2, 76, 10 );
}

class			clExit : public clNPC
{

public:

				clExit	( void );
	~			clExit	( void );

	void		Process	( void );

private:

};

clExit::clExit( void )
{
	this->menu.Free();
	this->menu.AddItem( clMenuItem( "", true ) );
	this->menu.AddItem( clMenuItem( "", false ) );
	this->text[ 0 ] = " ?";
}

void clExit::Process( void )
{
	if( ( chKey == 13 ) && ( this->menu.intActive == 0 ) )
	{
		Core::intGameState = GAME_TOTALQUIT;
	}
	if( ( chKey == 13 ) && ( this->menu.intActive == 1 ) )
	{
		Core::intGameState = GAME_NOWHERE;
	}
	Printf( 31, 32, this->text[ 0 ] );
	this->menu.Update();
	this->menu.Draw( 32, 36 );
}

clExit::~clExit( void )
{
}

class			clOnPlace : public clNPC
{

public:

				clOnPlace	( void );
	~			clOnPlace	( void );

	void		Process		( void );

private:

};

clOnPlace::clOnPlace( void )
{
	this->menu.Free();
	this->menu.AddItem( clMenuItem( " ", true ) );
	this->menu.AddItem( clMenuItem( " ", false ) );
	this->menu.AddItem( clMenuItem( "  ", false ) );
}

clOnPlace::~clOnPlace( void )
{
}

void clOnPlace::Process( void )
{
	switch( Core::intLevel )
	{
	case 0:
		this->text[ 0 ] = "    ,  ";
		this->text[ 1 ] = ".     ,";
		this->text[ 2 ] = "     .";
		this->menu.data[ 1 ].strName = "   ";

		break;
	case 1:
		this->text[ 0 ] = " ,    ,  ";
		this->text[ 1 ] = "  ,    ";
		this->text[ 2 ] = ".";
		this->menu.data[ 1 ].strName = "     ";

		break;
	case 2:
		this->text[ 0 ] = " ...     ";
		this->text[ 1 ] = "     , ";
		this->text[ 2 ] = " .   !";
		this->menu.data[ 1 ].strName = "  ";

		break;
	default:
		break;
	}

	if( ( chKey == 13 ) && ( this->menu.intActive == 0 ) )
	{
		Core::intGameState = GAME_BATTLE;
		Core::fht->intMonster = Core::intLevel * 3 + ( rand() % 2 );
		Core::manmon->data[ Core::fht->intMonster ].intHP = Core::manmon->data[ Core::fht->intMonster ].intHPmax;
	}

	if( ( chKey == 13 ) && ( this->menu.intActive == 1 ) )
	{
		if( !Core::plr->intQuest )
		{
			Core::intGameState = GAME_BATTLE;
			Core::fht->intMonster = Core::intLevel * 3 + 2;
			Core::manmon->data[ Core::fht->intMonster ].intHP = Core::manmon->data[ Core::fht->intMonster ].intHPmax;
		}
		else
		{
			char		ch[ 256 ];
			memset( ch, 0, 256 );
			sprintf( ch, "    " ); 
			SetColor( FOREGROUND_WHITE | FOREGROUND_INTENSITY );
			Printf( 31, 28, ch );
		}
	}

	if( ( chKey == 13 ) && ( this->menu.intActive == 2 ) )
	{
		Core::intGameState = GAME_NOWHERE;
	}

	Printf( 31, 32, this->text[ 0 ] );
	Printf( 31, 33, this->text[ 1 ] );
	Printf( 31, 34, this->text[ 2 ] );
	this->menu.Update();
	this->menu.Draw( 32, 36 );
}

class			clOldWoman : public clNPC
{

public:

				clOldWoman	( void );
	~			clOldWoman	( void );

	void		Process		( void );

private:

};

clOldWoman::clOldWoman( void )
{
	this->menu.Free();
	this->menu.AddItem( clMenuItem( "   ", true ) );
	this->menu.AddItem( clMenuItem( "  ", false ) );
	this->intText = 0x00;
}

clOldWoman::~clOldWoman( void )
{
}

void clOldWoman::Process( void )
{
	if( ( chKey == 13 ) && ( this->menu.intActive == 0 ) )
	{
		if( Core::plr->intQuestActive )
		{
			if( Core::plr->intQuest )
			{
				Core::plr->intQuestActive = 0x00;
				Core::plr->intQuest = 0x00;
				this->intText ++;
				Core::intLevel ++;
			}
			else
			{
				SetColor( FOREGROUND_WHITE );
				Printf( 31, 28, "    !" );
			}
		}
		if( this->intText == 0 )
		{
			this->intText ++;
			this->menu.data[ 0 ].strName = "  ";
			Core::plr->intQuestActive = 1;
		}
	}

	switch( this->intText )
	{
	case 0 :
		this->text[ 0 ] = "   ,    -";
		this->text[ 1 ] = ",  ,    ";
		this->text[ 2 ] = "- ...    ?";

		break;
	case 1:
		this->text[ 0 ] = "  !  ,    ";
		this->text[ 1 ] = " ,     ";
		this->text[ 2 ] = "     ...";

		break;
	case 2:
		this->text[ 0 ] = " [ ]  .";
		this->text[ 1 ] = "   ,   ";
		this->text[ 2 ] = " :       .";

		break;
	}

	if( ( chKey == 13 ) && ( this->menu.intActive == 1 ) )
	{
		Core::intGameState = GAME_NOWHERE;
	}

	Printf( 31, 32, this->text[ 0 ] );
	Printf( 31, 33, this->text[ 1 ] );
	Printf( 31, 34, this->text[ 2 ] );
	this->menu.Update();
	this->menu.Draw( 32, 36 );
	SetColor( FOREGROUND_WHITE );
	Core::manspr_npc->Draw( 1, 56, 2 );
	FrameDraw( 55, 2, 76, 10 );
}

class			clTakoyya : public clNPC
{

public:

				clTakoyya	( void );
	~			clTakoyya	( void );

	void		Process		( void );

private:

};

clTakoyya::clTakoyya( void )
{
	this->menu.Free();
	this->menu.AddItem( clMenuItem( "  ", true ) );
	this->menu.AddItem( clMenuItem( " ", false ) );
	this->intText = 0x00;
}

clTakoyya::~clTakoyya( void )
{
}

void clTakoyya::Process( void )
{
	if( ( chKey == 13 ) && ( this->menu.intActive == 0 ) )
	{
		if( Core::plr->intQuestActive )
		{
			if( Core::plr->intQuest )
			{
				Core::plr->intQuestActive = 0x00;
				Core::plr->intQuest = 0x00;
				Core::intLevel ++;
			}
			else
			{
				SetColor( FOREGROUND_WHITE );
				Printf( 31, 28, "    !" );
			}
		}
		if( this->intText == 1 )
		{
			this->menu.data[ 0 ].strName = "  ";
			Core::plr->intQuestActive = 1;
		}
		if( ( this->intText < 2 ) || ( ( this->intText > 1 ) && !Core::plr->intQuestActive ) )
		{
			this->intText ++;
		}
	}

	if( ( chKey == 13 ) && ( this->menu.intActive == 1 ) )
	{
		Core::intGameState = GAME_NOWHERE;
	}

	switch( this->intText )
	{
	case 0 :
		this->text[ 0 ] = "  , .";
		this->text[ 1 ] = "";
		this->text[ 2 ] = "";

		break;
	case 1:
		this->text[ 0 ] = "  ,    ...  ";
		this->text[ 1 ] = "    ";
		this->text[ 2 ] = "... ..  .";

		break;
	case 2:
		this->text[ 0 ] = "   ,    ";
		this->text[ 1 ] = "    .";
		this->text[ 2 ] = "     .";

		break;
	case 3:
		this->text[ 0 ] = " ,   ! , ";
		this->text[ 1 ] = "  ,    ";
		this->text[ 2 ] = "   ...";

		break;
	case 4:
		this->text[ 0 ] = "...    ";
		this->text[ 1 ] = "... ,    !!!";
		this->text[ 2 ] = "  ,   .";

		break;
	case 5:
		this->text[ 0 ] = "       ";
		this->text[ 1 ] = "   .";
		this->text[ 2 ] = "  ,    .";

		break;
	}

	Printf( 31, 32, this->text[ 0 ] );
	Printf( 31, 33, this->text[ 1 ] );
	Printf( 31, 34, this->text[ 2 ] );
	this->menu.Update();
	this->menu.Draw( 32, 36 );
	SetColor( FOREGROUND_WHITE );
	Core::manspr_npc->Draw( 2, 56, 2 );
	FrameDraw( 55, 2, 76, 10 );
}

void Printf( int x, int y, clString str )
{
	COORD		mpos;
	
	mpos.X = x;
	mpos.Y = y;

	CharToOem( str(), str() );
	SetConsoleCursorPosition( handleConsole, mpos );
	printf( str() );
}

void TitleLoadAndShow( char * ch )
{
	FILE		* f;

	f = fopen( ch, "r" );
	if( f )
	{
		fseek( f, 0, SEEK_END );
		int		intSize = ftell( f );
		fseek( f, 0, SEEK_SET );
		char	* chTitle = new char[ intSize ];
		memset( chTitle, 0, intSize );
		
		fread( chTitle, intSize, 1, f );
		Printf( 0, 0, chTitle );

		delete [] chTitle;

		fclose( f );
	}
	else
	{
		printf( "File %s not found", ch );
	}
}

void FrameDraw( int x0, int y0, int x1, int y1 )
{             
	COORD		mpos;
	int			i( 0 );

	mpos.X = x0;
	mpos.Y = y0;

	//    
	//  O----O
	//  |/  \|
	//  |\  /|
	//  O----O
	//   
	SetConsoleCursorPosition( handleConsole, mpos );
	printf( "O" );
	for( i = 0; i < abs( x1 - x0 ); i ++  )
	{
		printf( "-" );
	}
	printf( "O" );
	//   
	mpos.Y ++;
	mpos.X = x0;
	SetConsoleCursorPosition( handleConsole, mpos );
	printf( "|/" );
	mpos.X = x1;
	SetConsoleCursorPosition( handleConsole, mpos );
	printf( "\\|" );
	//  
	for( i = 0; i < abs( y1 - y0 ); i ++ )
	{
		mpos.Y ++;
		mpos.X = x0;
		SetConsoleCursorPosition( handleConsole, mpos );
		printf( "|" );
		mpos.X = x1 + 1;
		SetConsoleCursorPosition( handleConsole, mpos );
		printf( "|" );
	}
	//   
	mpos.Y ++;
	mpos.X = x0;
	SetConsoleCursorPosition( handleConsole, mpos );
	printf( "|\\" );
	mpos.X = x1;
	SetConsoleCursorPosition( handleConsole, mpos );
	printf( "/|" );
	//   
	mpos.X = x0;
	mpos.Y ++;
	SetConsoleCursorPosition( handleConsole, mpos );
	printf( "O" );
	for( i = 0; i < abs( x1 - x0 ); i ++  )
	{
		printf( "-" );
	}
	printf( "O" );
}

void BigFrameDraw( void )
{
	COORD		mpos;
	int			i( 0 );

	mpos.Y = 0;
	mpos.X = 0;
	SetColor( FOREGROUND_WHITE );
	SetConsoleCursorPosition( handleConsole, mpos );
	// 
	printf( "." );
	for( i = 0; i < 78; i ++  )
	{
		printf( "-" );
	}
	printf( "." );
	// 
	for( i = 0; i < 47; i ++ )
	{
		mpos.Y ++;
		mpos.X = 0;
		SetConsoleCursorPosition( handleConsole, mpos );
		printf( "|" );
		mpos.X = 79;
		SetConsoleCursorPosition( handleConsole, mpos );
		printf( "|" );
	}
	printf( "'" );
	for( i = 0; i < 78; i ++  )
	{
		printf( "-" );
	}
	printf( "'" );
}

void SetColor( int var )
{
	SetConsoleTextAttribute( handleConsole, var );
}

int main( void )
{
	srand( GetTickCount() );
	
	handleConsole = GetStdHandle( STD_OUTPUT_HANDLE );
	SetConsoleTextAttribute( handleConsole, FOREGROUND_RED | FOREGROUND_INTENSITY );
	TitleLoadAndShow( "Title.txt" );
	getch();

	// Initiliaze pointers

	Core::manspr_npc = new clManagerSprite( "NPC.txt" );
	Core::manwpn = new clManagerWeapon( "SpriteWeapon.txt", "DataWeapon.txt" );
	Core::manspr_stf = new clManagerSprite( "SpriteStuff.txt" );
	Core::manmon = new clManagerMonster( "SpriteMonster.txt", "DataMonster.txt" );
	Core::plr = new clPlayer( 500, 50, 50, 0, 1 );
	Core::fht = new clFight();
	Core::god = new clGod();

	// Game

	SetConsoleTextAttribute( handleConsole, FOREGROUND_WHITE );
	system( "cls" );

	clTrader		trd;
	clNowhere		nwr;
	clExit			ext;
	clOnPlace		plc;
	clMan			man;
	clOldWoman		wmn;
	clTakoyya		tky;

	Core::intGameState = GAME_GOD;
	Core::intLevel = 0x00;

	//  ,    
	int		OldGameState = 0;
	Core::boolPause = false;

	while( true )
	{
		system( "cls" );

		OldGameState = Core::intGameState;

		switch( Core::intGameState )
		{
		case GAME_GOD:
			Core::god->Process();
			break;
		case GAME_MAN:
			man.Process();
			break;
		case GAME_EXIT:
			ext.Process();
			break;
		case GAME_NOWHERE:
			nwr.Process();
			break;
		case GAME_TRADER:
			trd.Process();
			break;
		case GAME_ONPLACE:
			plc.Process();
			break;
		case GAME_BATTLE:
			Core::fht->Process();
			break;
		case GAME_WOMAN:
			wmn.Process();
			break;
		case GAME_TAKOYYA:
			tky.Process();
			break;
		default:
			Printf( 0, 0, "" );
			break;
		}

		if( Core::intGameState == GAME_TOTALQUIT )
		{
			break;
		}

		Core::plr->Process();
		
		BigFrameDraw();

		//   ?  ,     NPC     
		if( ( OldGameState == Core::intGameState ) || ( Core::boolPause ) )
		{
			chKey = getch();

			if( Core::boolPause )
			{
				Core::boolPause = false;
				chKey = 0x00;
			}
		}
		else
		{
			chKey = 0x00;	//    Enter'a
		}
	}

	delete Core::god;
	delete Core::fht;
	delete Core::plr;
	delete Core::manmon;
	delete Core::manspr_stf;
	delete Core::manwpn;
	delete Core::manspr_npc;

	return 0;
}