#include		"String.h"

clString::clString( const clString & str )
{
	this->intLength = strlen( str.chData );
	this->chData = new char[ this->intLength + 1 ];
	strcpy( this->chData, str.chData );
}

clString::clString( const char * chData )
{
	// Get length of string including 0x00 symbol
	this->intLength = strlen( chData );
	
	this->chData = new char[ this->intLength + 1 ];
	strcpy( this->chData, chData );
}

clString& clString::operator =	( const clString & str )
{
	this->intLength = strlen( str.chData );
	
	delete [] this->chData;

	this->chData = new char[ this->intLength + 1 ];
	strcpy( this->chData, str.chData );

	return ( * this );
}

clString& clString::operator +=	( const clString & str )
{	
	this->intLength += strlen( str.chData );
	
	char	* chRes = new char[ this->intLength + 1 ];
	
	strcpy( chRes, this->chData );
	strcat( chRes, str.chData );

	delete [] this->chData;
	this->chData = new char[ this->intLength + 1 ];
	strcpy( this->chData, chRes );
	
	delete [] chRes;
	
	return ( * this );
}

clString clString::operator +	( const clString & str )
{
	int		iLength = this->intLength + strlen( str.chData );
	char	* chDataTemp = new char[ iLength ];
	
	strcpy( chDataTemp, this->chData );
	strcat( chDataTemp, str.chData );
	
	return clString( chDataTemp );
}

clString clString::operator +	( const char * ch )
{
	int		iLength = this->intLength + strlen( ch );
	char	* chDataTemp = new char[ iLength ];
	
	strcpy( chDataTemp, this->chData );
	strcat( chDataTemp, ch );
	
	return clString( chDataTemp );
}


bool clString::operator == ( const clString & str )
{
	return ( !strcmp( this->chData, str.chData ) );
}

bool clString::operator == ( const char * ch )
{
	return ( !strcmp( this->chData, ch ) );
}

bool clString::operator != ( const clString & str )
{
	return ( strcmp( this->chData, str.chData ) );
}

bool clString::operator != ( const char * ch )
{
	return ( strcmp( this->chData, ch ) );
}

void clString::Add( const char * ch, const int intStart )
{
	if( ( intStart >= 0 ) && ( intStart <= this->intLength ) )
	{
		int		intAdd = strlen( ch );
		this->intLength += intAdd;
	
		char	* chRes = new char[ this->intLength + 1 ];
	
		strncpy( chRes, this->chData, intStart );
		strcpy( &chRes[ intStart ], ch );
		strcpy( &chRes[ intStart + intAdd ], &this->chData[ intStart ] );

		delete [] this->chData;
		this->chData = new char[ this->intLength + 1 ];
		strcpy( this->chData, chRes );
	
		delete [] chRes;
	}
}

void clString::CutEnd( const int intLength )
{
	if( ( intLength > 0 ) && ( intLength < this->intLength ) )
	{
		this->intLength -= intLength;
	
		char	* chRes = new char[ this->intLength + 1 ];
	
		strncpy( chRes, this->chData, this->intLength + 1 );

		delete [] this->chData;
		this->chData = new char[ this->intLength + 1 ];

		strcpy( this->chData, chRes );
		this->chData[ this->intLength ] = 0x00;
	
		delete [] chRes;
	}
}

void clString::Cut( const int intStart, const int intLength )
{
	int		intNew = ( intStart + intLength );

	if( ( intStart >= 0 ) && ( intStart < this->intLength ) &&
		( intNew > 0 ) && ( intNew < this->intLength ) )
	{
		this->intLength -= intLength;
	
		char	* chRes = new char[ this->intLength + 1 ];
	
		strncpy( chRes, this->chData, intStart );
		strcpy( &chRes[ intStart ], &this->chData[ intNew ] );

		delete [] this->chData;
		this->chData = new char[ this->intLength + 1 ];

		strcpy( this->chData, chRes );
		this->chData[ this->intLength ] = 0x00;
	
		delete [] chRes;
	}
}

void clString::funcSwap( const char chFind, const char * chRepl )
{
	int		iLengthStr = strlen( chRepl );
	int		iCountFound = 0;
	int		iLengthRes = 0;
	int		i, c = 0;

	for( i = 0; i < this->intLength + 1; i ++ )
	{
		if( this->chData[ i ] == chFind )
		{
			iCountFound ++;
		}
	}

	if( iCountFound > 0 )
	{
		char	* chRes = new char[ this->intLength + 1 ];
		memcpy( chRes, this->chData, this->intLength + 1 );
		delete [] this->chData;
		iLengthRes = this->intLength + ( iLengthStr ) * iCountFound;
		this->chData = new char[ iLengthRes + 1 ];

		for( i = 0; i < this->intLength + 1; i ++ )
		{
			if( chRes[ i ] != chFind )
			{
				this->chData[ c ] = chRes[ i ];
				c ++;
			}
			else
			{
				for( int j = 0; j < iLengthStr; j ++ )
				{
					this->chData[ c ] = chRepl[ j ];
					c ++;
				}
			}
		}
		this->chData[ iLengthRes ] = 0x00;
		this->intLength = iLengthRes;

		delete [] chRes;
	}
}

int clString::StripTags( void )
{
	int		i = 0, j = 0;
	bool	bInside = false;
	int		iNewSize = 0;

	for( i = 0; i < this->intLength + 1; i ++ )
	{
		if( this->chData[ i ] == '<' )
		{
			bInside = true;
		}
		if( this->chData[ i ] == '>' )
		{
			bInside = false;
		}

		if( ( !bInside ) && ( this->chData[ i ] != '>' ) && ( this->chData[ i ] != '<' ) )
		{
			iNewSize ++;
		}
	}

	char		* chRes = new char[ iNewSize + 1 ];

	for( i = 0; i < this->intLength + 1; i ++ )
	{
		if( this->chData[ i ] == '<' )
		{
			bInside = true;
		}
		if( this->chData[ i ] == '>' )
		{
			bInside = false;
		}
		
		if( ( !bInside ) && ( this->chData[ i ] != '>' ) && ( this->chData[ i ] != '<' ) )
		{
			chRes[ j ] = this->chData[ i ];
			j ++ ;
		}
	}

	chRes[ iNewSize ] = 0x00;

	delete [] this->chData;
	this->intLength = iNewSize - 1;
	
	this->chData = new char [ this->intLength + 1 ];
	strcpy( this->chData, chRes );

	return iNewSize;
}

void clString::ToUpper( void )
{
	strupr( this->chData );
}

void clString::ToLower( void )
{
	strlwr( this->chData );
}

int clString::Find( const char * ch )
{
	char	* p = strstr( this->chData, ch );

	if( p == NULL )
	{
		return - 1;
	}

	return ( p - this->chData );

	return - 1;
}

int clString::Find( const char * ch, int intStart )
{
	if( intStart < 0 )
	{
		intStart = 0;
	}
	if( intStart >= this->intLength )
	{
		return -1;
	}

	char	* p = strstr( &this->chData[ intStart ], ch );
	if( p == NULL )
	{
		return - 1;
	}

	return ( p - this->chData );

	return - 1;
}